﻿	$(document).ready(function(){
		// INITIAL
		init();
		var attemp = 0;
		
		// SOMETHING
		function init(){
			// CENTERED
			var left = 0;
			if ($("body").width() >= 984) {
				$(".result-box").removeAttr("style");
				$(".right-box").removeAttr("style");
				left = ($(window).width() - 970) / 2 - 7;
				if (left <= 0) left = 50;
				$(".result-box").css("padding-left", left);
			}
			else {
				$(".result-box").removeAttr("style");
				$(".right-box").removeAttr("style");
				left = ($(window).width() - 470) / 2 - 7;
				if (left <= 0) left = 50;
				$(".result-box").css("padding-left", left);
				$(".right-box").css("padding-left", left);
			}
		
			// MAKE LOADING CENTERED
			// WIDTH OF LOADING DIV IS 80PX;
			var tx = parseInt($("body").width() / 2 - 40);
			$(".loading").css("left", tx);
			
			$(window).resize(function(){
				// DIV CENTERED
				var left = 0;
				if ($("body").width() >= 984) {
					$(".result-box").removeAttr("style");
					$(".right-box").removeAttr("style");
					left = ($(window).width() - 970) / 2 - 7;
					if (left <= 0) left = 50;
					$(".result-box").css("padding-left", left);
				}
				else {
					$(".result-box").removeAttr("style");
					$(".right-box").removeAttr("style");
					left = ($(window).width() - 470) / 2 - 7;
					if (left <= 0) left = 50;
					$(".result-box").css("padding-left", left);
					$(".right-box").css("padding-left", left);
				}
				
				// LOADING
				var tx = parseInt($("body").width() / 2 - 40);
				$(".loading").css("left", tx);
			});
			
			// PROCESS HASH QUERY
			var q = getHash("q");
			var p = getHash("p");
			var play = getHash("play");
			if (p == "") p = 1;
			if (q != "") {
				setHash("q", decodeURIComponent(q));
				$(".first-searchbox").remove();
				appendSearchBox(decodeURIComponent(q));
				search(decodeURIComponent(q), p);
			}
			if (play != ""){
				$(".right-box").append("<div class='dummy-loading'><img src='images/loading-small.gif'/></div>");
				$.post("song.php", "id=" + play, function(res){
					$(".dummy-loading").remove();
					var data = $.parseJSON(res);
					appendWindowMedia(data.id, data.link, data.songname, data.singer, data.category, data.quality, data.amount, data.lyric, data.download);
					document.title = "Nghe bài hát " + data.songname + " - " + data.singer + " - XTremal MP3 - Nghe Nhạc Hay";
				});
			}
		}
		
		// SEARCH FROM FORM
		$(document).on("submit", "#fSearch", function(){
			if ($.trim($("#q").val()).length > 0){
				if ($(".first-searchbox").length > 0){
					var k = $("#q").val();
					$(".first-searchbox").remove();
					appendSearchBox(k);
				}
				
				if ($("#q").val().split("http://mp3.zing.vn/bai-hat/").length == 2){
					if ($(".music-player-box").length > 0)
						jwplayer("myElement").stop();
					$(".music-player-box").empty().remove();	// REMOVE LAST MEDIA
					$(".right-box .result-msg").empty().remove();
					$(".right-box").append("<div class='dummy-loading'><img src='images/loading-small.gif'/></div>");
					$(".loading").fadeIn(300);
					$(".btnSearch").attr("disabled", "disabled").css({"opacity" : "0.3", "cursor" : "default"});
					
					var id = $("#q").val().split("/");
					id = id[id.length - 1];
					id = id.split(".")[0];
					
					$.post("song.php", "id=" + id, function(res){
						if (res != "error") {
							$(".dummy-loading").remove();
							
							var data = $.parseJSON(res);
							appendWindowMedia(data.id, data.link, data.songname, data.singer, data.category, data.quality, data.amount, data.lyric, data.download);
							document.title = "Nghe bài hát " + data.songname + " - " + data.singer + " - XTremal MP3 - Nghe Nhạc Hay";
							
							$("#q").val(data.songname);
							setHash("q", data.songname);
							setHash("p", "1");
							setHash("play", id);
							search(data.songname, 1);
							
							$(".loading").fadeOut(300);
						} else {
							$(".dummy-loading").remove();
							if ($(".music-player-box").length > 0)
								jwplayer("myElement").stop();
							$(".music-player-box").empty().remove();	// REMOVE LAST MEDIA
							$(".right-box").append('<div class="result-msg">Đường dẫn không hợp lệ</div>');
							$(".loading").fadeOut(300);
							$(".btnSearch").removeAttr('disabled').removeAttr("style");
						}
					});
				} else {
					setHash("q", $("#q").val());
					setHash("p", "1");
					search($("#q").val(), 1);
				}
			}
			return false;
		});
		
		// SEARCH FORM PAGINATION
		$(document).on("click", ".pageElem", function(){
			setHash("q", $(this).attr("k"));
			setHash("p", $(this).attr("p"));
			search($(this).attr("k"), $(this).attr("p"));
		});
		
		function search(key, page){
			closeFooter();
			document.title = "Tìm bài hát " + key + " - XTremal MP3 - Nghe Nhạc Hay";
			$.ajax({
				type: "POST",
				url: "search.php",
				data: "q=" + key + "&p=" + page,
				beforeSend: function(){
					$(".btnSearch").attr("disabled", "disabled").css({"opacity" : "0.3", "cursor" : "default"});
					$(".result-box").empty().html("<center><img src='images/loading.gif'/></center>");
					$("body").animate({scrollTop: 0}, 500);
				},
				success: function(res){
					// SET BUTTON SEARCH TO DEFAULT
					$(".btnSearch").removeAttr('disabled').removeAttr("style");
					
					if (res == "network") { // NETWORK ERRORS
						attemp++;
						if (attemp > 5) { // TRYING TO CONNECT 5 TIMES
							attemp = 0;	// SET TO DEFAULT
							$(".result-box").empty().html('<div class="result-msg">Không thể kết nối đến máy chủ. Vui lòng thử lại</div>');
						}
						else 
							search(key, page); // TRYING TO CONNECT AGAIN
					}
					else if (res == "empty")	// NO RESULT
						$(".result-box").empty().html('<div class="result-msg">Không tìm thấy kết quả nào với <b>' + key + '</b></div>');
					else {	// PRINT RESULTS
						if (!$(".result-box").is(":empty"))
							$(".result-box").empty();
						$(".result-box").html('<div class="result-msg">Kết quả tìm kiếm với <b>' + key + '</b></div>');
						$(".result-box").append(res);
					}
				}
			});
		}
		
		// CLOSE FOOTER
		function closeFooter(){
			if ($(".footer").length > 0){
				$(".footer").fadeOut(600, function(){
					$(this).remove();
				});
			}
		}
		
		// PLAY
		$(document).on("click", ".song", function(){
			$(".loading").fadeIn(300);
			setHash("play", $(this).attr("id"));
			$(this).play();
		});
		
		// DOWNLOAD
		$(document).on("click", ".result-download, .download", function(){
			$(".loading").fadeIn(300);
			$(this).download();
		});			
		
		var mInit = true;
		$.fn.play = function(){
			if (mInit){
				mInit = false;
				if ($("body").width() >= 984)
					$("body").animate({scrollTop: 90}, 600);
				if ($(".music-player-box").length > 0)
				jwplayer("myElement").stop();
				$(".music-player-box").empty().remove();	// REMOVE LAST MEDIA
				
				var id = $(this).attr("id");
				var link = $(this).attr("link");
				var download = $(this).siblings(".result-download").attr("link");
				var songname = $(this).text();
				var singer = $(this).closest(".result-song").next(".result-des").text();
				document.title = "Nghe bài hát " + songname + " - " + singer + " - XTremal MP3 - Nghe Nhạc Hay";
				var category = $(this).closest(".result-song").next().next().children(".category").text();
				var quality = $(this).closest(".result-song").next().next().children(".quality").text();
				var amount = $(this).closest(".result-song").next().next().children(".amount").text();
				
				if ($(this).attr("link") != "get") {
					appendWindowMedia(id, link, songname, singer, category, quality, amount, "<img src='images/loading-small.gif'/>", download);
					$.post("lyric.php", "id=" + $(this).attr("id"), function(res){
						$(".player-lyric").empty().html(res);
					});
				} else {
					$.post("buy.php", "id=" + $(this).attr("id"), function(res){
						var data = $.parseJSON(res);
						appendWindowMedia(id, data.link, songname, singer, category, quality, amount, data.lyric, download);
					});
				}
				onPlayingEff(this);
			}
		}
		
		$.fn.download = function(){
			var id = $(this).attr("id");
			var link = $(this).attr("link");
			
			$.ajax({
				type: "POST",
				url: "download.php",
				data: "id=" + id + "&link=" + link,
				success: function(res){
					$(".iframe-dl").append("<iframe src='" + res + "'/>");
					$(".loading").fadeOut(300);
				}
			});
		}
		
		// POPUP LYRIC
		$(document).on("click", ".lyric", function(e){
			e.stopPropagation();
			if ($(".lyric-popup").length == 0)
				$(document.body).append("<div class='lyric-popup'><center><img src='images/loadingbk.gif'/></center></div>");
			$(".lyric-popup").css({"top" : (e.pageY - 10), "left" : (e.pageX + 15)}).hide().fadeIn(300);
		
			$("body").click(function(){
				$(".lyric-popup").fadeOut(250, function(){
					$(this).remove();
				});
				$("body").unbind("click");
			});
			
			// AJAX
			$.post("lyric.php", "id=" + $(this).prev().attr("id"), function(res){
				$(".lyric-popup").empty().css({"width" : 330}).html(res).hide().fadeIn(300);
			});
		});
		
		function onPlayingEff(sel){
			$(".result-line").removeAttr("style");
			sel.closest(".result-line").css("background-color", "lavender");
		}
		
		function appendWindowMedia(id, link, songname, singer, category, quality, amount, lyric, download){
			var html =	'<div class="music-player-box">';
			html +=	'<div class="music-player-box-title">Music Player</div>';
			html +=	'<div class="win-player">';
			html +=	'<div id="myElement">Loading the player...</div>';
			html +=	'<script type="text/javascript">';
			html +=	'jwplayer("myElement").setup({';
			html +=	'"file": "http://mp3.zing.vn/html5/song/' + link + '/.mp3",';
			html +=	'"image": "images/playerbg.jpg",';
			html +=	"'autostart': 'true',";
			html +=	"'repeat': 'true',";
			html +=	"'width': '100%',";
			html +=	"'height': '150',";
			html +=	'});';
			html +=	'</script>';
			html +=	'</div>';
			html +=	'<div class="player-des"><div class="pTitle">Ca khúc</div><div class="pContent">' + songname + '</div></div>';
			html +=	'<div class="player-des"><div class="pTitle">Ca sĩ</div><div class="pContent">' + singer + '</div></div>';
			html +=	'<div class="player-des"><div class="pTitle">Thể loại</div><div class="pContent">' + category + '</div></div>';
			html +=	'<div class="player-des"><div class="pTitle">Chất lượng</div><div class="pContent">' + quality + '</div></div>';
			html +=	'<div class="player-des"><div class="pTitle">Lượt nghe</div><div class="pContent">' + amount + '</div></div>';
			html +=	'<div class="player-des"><div id="' + id + '" link="' + download + '" style="cursor: pointer;" class="pTitle download" title="Tải về">Download</div><div style="padding: 6px;">&nbsp;</div></div>';
			html +=	'<div class="player-des"><div class="pTitle">Lời nhạc</div><div class="pContent">&nbsp;</div></div>';
			html +=	'<div class="player-lyric">' + lyric + '';
		//	html +=	'<div class="seemore-lyric">Xem thêm</div>';
			html +=	'</div>';
			html +=	'<hr class="hr-lyric"><div class="player-copyright"><b>LuanXT © 2013</b></div>';
			html +=	'</div>';
			$(".right-box").append(html);

			// SCROLLTOP
			if ($("body").width() < 984)
				//alert($(".music-player-box").offset().top);
				$("body").animate({scrollTop: 1732}, 600);			
			
			$(".music-player-box").hide().fadeIn();
			jwplayer("myElement").onPlay(function() {
				mInit = true;
				$(".loading").fadeOut(300);
			});
			
			jwplayer("myElement").onError(function() {
				mInit = true;
				$(".loading").fadeOut(300);
			});
			
			jwplayer("myElement").onReady(function() {
				$(".jwclick_item").empty().text("LuanXT © 2013");
			});
		}
		
		function appendSearchBox(keyword){
			var html = '<form id="fSearch">';
				html += '<input value="' + keyword + '" style="margin-top: 0;" id="q" type="text" name="q" placeholder="Nhập tên bài hát hoặc ca sĩ" spellcheck="false"/>';
				html += '<input class="btnSearch" type="submit" value=" "/>';
				html += '</form>';
			$(".right-box").prepend(html).hide().fadeIn();
		}
		
		$(document).on("dblclick", "#q", function(){
			$(this).val("");
		});
		
		function getHash(key){
			key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
			// var exp = "[\\?&]"+key+"=([^&#]*)";
			var exp = key + "=([^&]*)";
			var regexp = new RegExp(exp);	
			var results = regexp.exec(window.location.href);
			if (results == null)	return "";
			else	return results[1];
		}
		
		function setHash(key, val){
			var q = getHash("q");
			var p = getHash("p");
			var play = getHash("play");
			var h1 = "";
			var h2 = "";
			var h3 = "";
			
			if (q != "") h1 = "q=" + q;
			if (p != "") h2 = "&p=" + p;
			if (play != "") h3 = "&play=" + play;
			
			
			if (key == "q") h1 = "q=" + val;
			else if (key == "p") h2 = "&p=" + val;
			else if (key == "play") h3 = "&play=" + val;
			if (h2 == "&p=1") h2 = "";
			window.location.hash = h1 + h2 + h3;
		}
	});